//
//  OnOpenURLDemoApp.swift
//  OnOpenURLDemo
//
//  Created by Gabriel Theodoropoulos.
//  https://serialcoder.dev
//

import SwiftUI

@main
struct OnOpenURLDemoApp: App {
    var body: some Scene {
        WindowGroup {
            ContentView()
                .onOpenURL { url in
                    if url.pathExtension == "json" {
                        do {
                            let data = try Data(contentsOf: url)
                            let note = try JSONDecoder().decode(Note.self, from: data)
                            NotificationCenter.default.post(name: .didImportNote, object: note)
                        } catch {
                            print(error.localizedDescription)
                        }
                    } else {
                        // Handle gracefully an unknown file.
                        print("Unknown file type!")
                    }
                }
        }
    }
}

extension Notification.Name {
    static let didImportNote = Self("didImportNote")
}
